diff --git a/drivers/dma-buf/Makefile b/drivers/dma-buf/Makefile
index 1ef021273a06..511805dbeb75 100644
--- a/drivers/dma-buf/Makefile
+++ b/drivers/dma-buf/Makefile
@@ -11,6 +11,7 @@ obj-$(CONFIG_DMABUF_SYSFS_STATS) += dma-buf-sysfs-stats.o
 dmabuf_selftests-y := \
 	selftest.o \
 	st-dma-fence.o \
-	st-dma-fence-chain.o
+	st-dma-fence-chain.o \
+	st-dma-resv.o
 
 obj-$(CONFIG_DMABUF_SELFTESTS)	+= dmabuf_selftests.o
diff --git a/drivers/dma-buf/selftests.h b/drivers/dma-buf/selftests.h
index bc8cea67bf1e..97d73aaa31da 100644
--- a/drivers/dma-buf/selftests.h
+++ b/drivers/dma-buf/selftests.h
@@ -12,3 +12,4 @@
 selftest(sanitycheck, __sanitycheck__) /* keep first (igt selfcheck) */
 selftest(dma_fence, dma_fence)
 selftest(dma_fence_chain, dma_fence_chain)
+selftest(dma_resv, dma_resv)
diff --git a/drivers/dma-buf/st-dma-resv.c b/drivers/dma-buf/st-dma-resv.c
new file mode 100644
index 000000000000..ea44769d058d
--- /dev/null
+++ b/drivers/dma-buf/st-dma-resv.c
@@ -0,0 +1,164 @@
+/* SPDX-License-Identifier: MIT */
+
+/*
+* Copyright © 2019 Intel Corporation
+*/
+
+//#include <linux/delay.h>
+//#include <linux/dma-fence.h>
+//#include <linux/kernel.h>
+//#include <linux/kthread.h>
+//#include <linux/sched/signal.h>
+
+#include <linux/slab.h>
+#include <linux/spinlock.h>
+#include <linux/dma-resv.h>
+
+#include "selftest.h"
+
+static struct spinlock fence_lock;
+
+static const char *fence_name(struct dma_fence *f)
+{
+	return "selftest";
+}
+
+static const struct dma_fence_ops fence_ops = {
+	.get_driver_name = fence_name,
+	.get_timeline_name = fence_name,
+};
+
+static struct dma_fence *alloc_fence(void)
+{
+	struct dma_fence *f;
+
+	f = kmalloc(sizeof(*f), GFP_KERNEL);
+	if (!f)
+		return NULL;
+
+	dma_fence_init(f, &fence_ops, &fence_lock, 0, 0);
+	return f;
+}
+
+static int sanitycheck(void *arg)
+{
+	struct dma_fence *f;
+
+	f = alloc_fence();
+	if (!f)
+		return -ENOMEM;
+
+	dma_fence_signal(f);
+	dma_fence_put(f);
+	return 0;
+}
+
+static int test_excl_signaling(void *arg)
+{
+	struct dma_resv resv;
+	struct dma_fence *f;
+	int err = -EINVAL;
+
+	f = alloc_fence();
+	if (!f)
+		return -ENOMEM;
+
+	dma_resv_init(&resv);
+	dma_resv_add_excl_fence(&resv, f);
+	if (dma_resv_test_signaled(&resv, false)) {
+		pr_err("Resv unexpectedly signaled\n");
+		goto err_free;
+	}
+	dma_fence_signal(f);
+	if (!dma_resv_test_signaled(&resv, false)) {
+		pr_err("Resv not reporting signaled\n");
+		goto err_free;
+	}
+	err = 0;
+err_free:
+	dma_resv_fini(&resv);
+	dma_fence_put(f);
+	return err;
+}
+
+static int test_shared_signaling(void *arg)
+{
+	struct dma_resv resv;
+	struct dma_fence *f;
+	int err;
+
+	f = alloc_fence();
+	if (!f)
+		return -ENOMEM;
+
+	dma_resv_init(&resv);
+	err = dma_resv_reserve_shared(&resv, 1);
+	if (err) {
+		pr_err("Resv shared slot allocation failed\n");
+		goto err_free;
+	}
+
+	err = -EINVAL;
+	dma_resv_add_shared_fence(&resv, f);
+	if (dma_resv_test_signaled(&resv, true)) {
+		pr_err("Resv unexpectedly signaled\n");
+		goto err_free;
+	}
+	dma_fence_signal(f);
+	if (!dma_resv_test_signaled(&resv, true)) {
+		pr_err("Resv not reporting signaled\n");
+		goto err_free;
+	}
+	err = 0;
+err_free:
+	dma_resv_fini(&resv);
+	dma_fence_put(f);
+	return err;
+}
+
+static int test_excl_for_each(void *arg)
+{
+	struct dma_resv_iter cursor;
+	struct dma_fence *f, *fence;
+	struct dma_resv resv;
+	int err;
+
+	f = alloc_fence();
+	if (!f)
+		return -ENOMEM;
+
+	dma_resv_init(&resv);
+	dma_resv_add_excl_fence(&resv, f);
+
+	err = -EINVAL;
+	dma_resv_for_each_fence(&cursor, &resv, false, fence) {
+		if (f != fence) {
+			pr_err("Unexpected fence\n");
+			goto err_free;
+		}
+		err = 0;
+	}
+	if (err) {
+		pr_err("No fence found\n");
+		goto err_free;
+	}
+	dma_fence_signal(f);
+	err = 0;
+err_free:
+	dma_resv_fini(&resv);
+	dma_fence_put(f);
+	return err;
+}
+
+int dma_resv(void)
+{
+	static const struct subtest tests[] = {
+		SUBTEST(sanitycheck),
+		SUBTEST(test_excl_signaling),
+		SUBTEST(test_shared_signaling),
+		SUBTEST(test_excl_for_each),
+	};
+
+	spin_lock_init(&fence_lock);
+	return subtests(tests, NULL);
+}